/* Placed in the Public Domain 5/25/97  John E. Carter */
/* johnecarter@mindspring.com                          */
/* compiles under Turbo C 2.0 or higher                */
/*                                                     */
/* this started as a utility to get the local machine's name */
/* on LAN Manager 2.1a.  Extended to check for LANtastic. */
/* John E. Carter - 07/20/93 */
/* 02/20/95 - changed check of gets() */
/* 02/18/95 - added check for LASTDRIVE */
/* 02/16/95 - added error exit codes: 1 no network, 2 running under Windows */
/* 02/15/95 - made Windows directory array larger */
/* 08/16/94 - revised report format */
/* 08/07/94 - added check for LANtastic */
/* 06/21/94 - changed wording of CD report */
/* 05/29/94 - changed CD-ROM check */
/* 09/16/93 - added ASSIGN and DRIVER.SYS checking, added debug outputs */
/* 09/15/93 - moved remote device list to bottom of output (jec) */
/* 09/14/93 - added version of APPEND (jec) */
#include <stdio.h>
#include <dos.h>

main(argc,argv)
int argc;
char argv[];
{
  extern char *getenv();
 /* source and destination register structures */
  union REGS reg, *sregp, *dregp;
  struct SREGS sreg, *segregp;
  struct dfree dspc;
  long diskfree, diskmax;
  static char sccs_id[] = "@(#) netstat.c (Turbo C) 02/20/95 (jec)";
  char myname[16], windir[80], devname[17], netdev[129];
  char *cp, *wp, strlong[20], ndrv[17], npath[129];
  unsigned lastdrv, ncx;
  float f, pctfree;
  int c, i, firstcd, isremote, curdisk, bl, bh, carryflag, dodebug;
  int int13, al, ah, cl, ch, dl, dh, req, underwin;
  unsigned int bx, es, ds, sec_clus, avl_clus, byte_sec, clus_drv;
  int dosmajor, dosminor;
  sregp = &reg;
  dregp = &reg;
  segregp = &sreg;
  bl = firstcd = bx = 0;
  carryflag = req = c = i = al = ah = dodebug = underwin = lastdrv = ncx = 0;
  cp = &myname[0];
  wp = &windir[0];
  for(i=0;i<16;i++)       /* initialize the char arrays */
  {
    devname[i] = '\0';
    myname[i] = '\0';
    ndrv[i] = '\0';
  }
  for(i = 0; i < 129;i++)
  {
    netdev[i] = '\0';
    npath[i] = '\0';
  }
  if(argc > 1)
    dodebug = argc -1;
  clrscr();  /* clear screen */
  printf("\nPC network status report - Turbo C version 02/20/95 (jec)\n");
  printf("johnecarter@mindspring.com\n");
/* get current drive and space */
  if(dodebug > 0)
    printf("Checking for current drive and space: ");

  i = getdisk() + 1;          /* get current disk */
  getdfree(i, &dspc);         /* get cluster, sector, byte info */
  diskmax = (long)dspc.df_total * (long)dspc.df_bsec * (long)dspc.df_sclus;
  diskfree = (long)dspc.df_avail * (long)dspc.df_bsec * (long)dspc.df_sclus;
  pctfree = ((float)(diskmax - diskfree)/(float)diskmax) * 100;
  printf("\nDisk %c: is %5.1f%% full ",64+i,pctfree);
  sprintf(strlong,"%ld",diskfree);  /* put number into string */
  addcommas(strlong);               /* put commas in number */
  printf("(%s bytes free of ",strlong);
  sprintf(strlong,"%ld",diskmax);  /* put number into string */
  addcommas(strlong);              /* put commas in number */
  printf("%s bytes total)\n",strlong);


/* check if running in DOS box under Windows */
  if(dodebug > 0)
    printf("Checking if Windows is active: ");

  if((wp = getenv("windir")) != NULL)
  {
    printf("\nWindows active from %s",wp);
    underwin = 2;
  }

/* check DOS version, as some things checked later are version specific */
  if(dodebug > 0)
    printf("\nChecking DOS version: ");

  reg.x.ax = 0x3000;
  int86(0x21,sregp, dregp);
  if(dodebug > 1)
    showregs(dregp);
  dosmajor = reg.x.ax & 255;  /* lo byte, version_major */
  if (reg.x.ax > al)
    dosminor = reg.x.ax >> 8; /* hi byte, version_minor */
  else
    dosminor = 0;

  printf("\nDOS version: %d.%d",dosmajor, dosminor);

/* get highest drive letter */
/* getdisk() gets current drive #, setdisk(drv#) returns highest drive # */
lastdrv = setdisk(getdisk());  
printf("\tLASTDRIVE: %c\n",'A' -1 + lastdrv);

/* check for driver.sys */
  if(dodebug > 0)
  {
    printf("Checking for DRIVER.SYS: ");
    if((dosmajor < 3) && (dosminor < 2))
      printf("Can't check for DRIVER.SYS: DOS version too low\n");
    else
    {
      printf("DRIVER.SYS: ");
      reg.x.ax = 0x0800;
      int86(0x2f, sregp, dregp);
      if(dodebug > 1)
        showregs(dregp);

      if((reg.x.ax & 255) == 255)
        printf("not ");

      printf("loaded\n");
    }
  }

/* check for ASSIGN */
  if(dodebug > 0)
  {
    printf("Checking for ASSIGN: ");
    if(dosmajor < 3)
      printf("Can't check for ASSIGN: DOS version too low\n");
    else
    {
/*      printf("ASSIGN: "); */
      reg.x.ax = 0x0600;
      int86(0x2f, sregp, dregp);
      if(dodebug > 1)
        showregs(dregp);

      if((reg.x.ax & 255) != 0)
	printf("ASSIGN loaded\n");
    }
  }

/* check for APPEND */
  if(dodebug > 0)
    printf("Checking for APPEND: ");

  if((dosmajor < 3) && (dosminor < 3))
    printf("Can't check for APPEND: DOS version too low\n");
  else
  {
/*    printf("APPEND: "); */
    reg.x.ax = 0xb700;        /* b700 gets loaded or not */
    int86(0x2f,sregp, dregp);
    if(dodebug > 1)
      showregs(dregp);
/*****
    if((reg.x.ax & 255) != 255)
      printf("not ");
    else
****/
    if((reg.x.ax & 255) == 255)
    {
      reg.x.ax = 0xb710;   /* b710 gets version */
      int86(0x2f,sregp, dregp);
      if(dodebug > 1)
        showregs(dregp);
      printf("APPEND version %d.%d loaded\n",reg.x.dx & 255, reg.x.dx / 256);
    }
/*    printf("loaded\n"); */
  }

/* check for SHARE */
  if(dodebug > 0)
    printf("Checking for SHARE: ");

  if (dosmajor < 3)
    puts("Can't check for SHARE: DOS version too low.");
  else
  {
/*    printf("SHARE: "); */
    reg.x.ax = 0x1000;
    int86(0x2f,sregp, dregp);
    if(dodebug > 1)
      showregs(dregp);
/****
    if((reg.x.ax & 255) != 255)
      printf("not ");
****/
    if((reg.x.ax & 255) == 255)
	printf("SHARE loaded\n");
  }

/* check for CD-ROM drives */
  if(dodebug > 0)
    printf("Checking for CD-ROM drives: ");

  reg.x.ax = 0x1500;
  int86(0x2f,sregp, dregp);
  if(dodebug > 0)
    showregs(dregp);
  al = reg.x.ax & 255;
  bx = reg.x.bx & 255;
  if(al == 255 && bx > 0)  /* was != */
  {
    printf("\nCDROM: ");
    firstcd = reg.x.cx;
    if (bx > 1)
    {
      printf("%d drives beginning at ",bx);
    }
    printf("%c\n", firstcd + 65);
  }

  if(firstcd > 0)
    firstcd++;  /* MSCDEX call returns 0 based #, next check uses 1 based */

/* check for NETBIOS */
  if(dodebug > 0)
    printf("Checking for NETBIOS: ");

/*  printf("NETBIOS: "); */
  reg.x.ax = 0;
  int86(0x2a,sregp, dregp);
  if(dodebug > 1)
    showregs(dregp);
  ah = reg.x.ax >> 8;
/***
  if (ah == 0)
    printf("not ");
  else
***/
  if (ah != 0)
  {
    req++;                   /* increment network flag */
    printf("NETBIOS loaded\n");
  }

/* check for network installation pieces */


  if(dodebug > 0)
    printf("Checking for network drivers\n");

  reg.x.ax = 0xb800;
  int86(0x2a,sregp, dregp);
  if(dodebug > 1)
    showregs(dregp);
  if(reg.x.ax & 255 > 0)
  {
    req++;
    printf("\Net functions loaded: ");
    bl = reg.x.bx & 255;
    if(bl & 64)
      printf("server ");
    if(bl & 4)
      printf("messenger ");
    if(bl & 128)
      printf("receiver ");
    if(bl & 8)
      printf("redirector");
    printf("\n");
  }

    /* get redirection list */
  if(req > 0)
  {
    /* check LANtastic software version */
    reg.x.ax = 0xb809;
    int86(0x2f,sregp,dregp);
    ah = reg.x.ax >> 8;
    al = reg.x.ax & 255;
    if ((ah > 0) && (al != 9))
      printf("LANtastic version %d.%d\n",ah,al);

    if(dodebug > 0)
      printf("Checking for network devices\n");

    i = 0;
    while(carryflag == 0)
    {
      reg.x.ax = 0x5f02;
      reg.x.bx = i;
      reg.x.si = FP_OFF(&devname[0]);
      segregp->ds = FP_SEG(&devname[0]);
      segregp->es = FP_SEG(&netdev[0]);
      reg.x.di = FP_OFF(&netdev[0]);
      int86x(0x21, sregp, dregp, segregp);
      if(dodebug > 1)
        showregs(dregp);
      carryflag = reg.x.flags & 1;
      if(carryflag == 0)
      {
        if(reg.x.bx >> 8 == 0)       /* valid entry */
        {
	  printf("Device type: ");
          switch(reg.x.bx & 255)
          {
	    case 3: printf("printer");
                    break;
	    case 4: printf("drive  ");
                    break;
	    default: printf("unknown");
          }
          printf("  Name: %s",devname);
	  for(c=strlen(devname);c<12;c++)
           printf(" ");
	  printf("Destination: %s", netdev);
	  printf("\tCX=%u\n",reg.x.cx);
	  i++;
        }
      }
    }
  }

/* get network name of this machine */
  if(req > 0)
  {
    if(dodebug > 0)
      printf("Getting machine name: ");

    printf("Machine name: ");
    reg.x.ax = 0x5e00;
    segregp->ds = FP_SEG(cp);
    reg.x.dx = FP_OFF(cp);
    int86x(0x21, sregp, dregp, segregp);
    if(dodebug > 1)
      showregs(dregp);
    if((reg.x.cx >> 8) == 0)
      printf("none\n");
    else
    {
      for(i=0;i<strlen(myname);i++)
        if(myname[i] == 32)
          myname[i] = '\0';

      printf("%s\n",myname);

/**************** this seems to always be 2 in LAN Manager ****************/
      printf("Name number: %d\n",reg.x.cx & 255);

    }

    /* get network software version */
  if(req >0)
  {
    if(dodebug > 0)
      printf("Checking network software version: ");

    reg.x.ax = 0xb809;
    int86(0x2f,sregp, dregp);
    if(dodebug > 1)
      showregs(dregp);
    al = reg.x.ax & 255;
    ah = (reg.x.ax >> 8)/10;
    printf("Net software version: %d.%d\n",ah,al);
  }
 }

  /* get count of network resources */
  if(req > 0)
  {
    if(dodebug > 0)
      printf("Checking network resource count\n");

    reg.x.ax = 0x0500;
    int86(0x2a,sregp, dregp);
    if(dodebug > 1)
      showregs(dregp);
/* always get 0 back from this call in LAN Manager */
    printf("Net names available: %d\n",reg.x.bx);
    printf("Net command blocks available: %d\n",reg.x.cx);
    printf("Net sessions available: %d\n",reg.x.dx);
  }
  if(req == 0)
    printf("\nNo network found\n");
  else
  {
    printf("Add a connection? (Y/N) ");
    gets(ndrv);
    if (strlen(ndrv) > 0)
      if(toupper(ndrv[0]) == 'Y')
      {
	printf("Drive letter: ");
	gets(ndrv);
	printf("\nNetwork path: ");
	gets(npath);
	i = addnetdrv(ndrv, npath, ncx);
	if (i == 0)
	  printf("\nAdded\n");
	else
	  printf("\nNetwork error: %d\n",i);
      }        /* end of ndrv = 'Y' */
  } /* end of if (req) */

  if(underwin == 0 && req == 0)
      underwin = 1;

  exit(underwin);
}

/* Let's C has a picture() function, but this is portable to any compiler */
addcommas(strlong)
char *strlong;
{
  int strl, i, curpos;
  char workstr[20], *strp, *wrkp;
  for(i=0;i<20;i++)
    workstr[i] = '\0';

  strl = strlen(strlong);
  curpos = 0;
  wrkp = &workstr[0];      /* first byte */
  strp = &strlong[strl -1];  /* last byte */
  for(i = strl -1;i >- 1;i--)  /* copy bytes in reverse order */
  {
    *wrkp++ = *strp--;
    curpos++;
    if(curpos == 3)      /* insert a comma every third digit */
    {
      curpos = 0;
      *wrkp++ = ',';
    }
  }
  *wrkp = '\0';
  strp = &strlong[0];
  wrkp = &workstr[strlen(workstr)-1];
  for(i=0;i < strlen(workstr);i++)       /* change back to original order */
    *strp++ = *wrkp--;
  *strp = '\0';
  if(strlong[0] == ',')             /* delete first char if it is "," */
    strlong[0] = ' ';
}

showregs(dregp)
union REGS *dregp;
{
  printf("ax=%04.4x, bx=%04.4x, cx=%04.4x, dx=%04.4x\n",dregp->x.ax,dregp->x.bx,dregp->x.cx,dregp->x.dx);
}

addnetdrv(ndrv, npath, ncx)
char *ndrv, *npath;
unsigned ncx;
{
/*  int carryflag; */
  union REGS reg, *sregp, *dregp;
  struct SREGS sreg, *segregp;
  sregp = &reg;
  dregp = &reg;
  segregp = &sreg;

  reg.x.ax = 0x5f03;
  reg.x.si = FP_OFF(&ndrv[0]);
  segregp->ds = FP_SEG(&ndrv[0]);
  segregp->es = FP_SEG(&npath[0]);
  reg.x.di = FP_OFF(&npath[0]);
  int86x(0x21, sregp, dregp, segregp);
/*  carryflag = reg.x.flags & 1; */
/*  if (carryflag > 0) */  /* carry set on error */
    return(reg.x.ax);   /* error in ax */
}

/****************  universal clear screen *************/
/****************
  for(i=0;i<24;i++)
    putchar('\n');
****************/


/**************** get network address - Novell only *************/
/****************
    reg.x.ax = 0xee00;
    intcall(sregp, dregp, 0x21);
    printf("Net address: %04x:%04x:%04x\n",reg.x.cx,reg.x.bx,reg.x.ax);
****************/

